/*  ftplite 
    Ȩ(C)  2003

    һ GNU ͨù
֤޸ĺ·һ򡣻֤ĵڶ棬ߣѡ
κθµİ汾
    һĿϣãûκεûʺضĿ
ĵĵϸ GNU ͨù֤
    ӦѾͳһյһ GNU ͨù֤ĸûУ
дŸ
    The Free Software Foundation, Inc.,  675  Mass Ave,  Cambridge,
    MA02139,  USA

    ڱʲô⣬ϵ
    E-mailedyfox@sohu.com */
#include <sstream>
#include <cstdlib>
#include <cerrno>
#if defined(UNIX) || defined(LINUX)
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#else
#include <direct.h>
#include <io.h>
#endif
#include "ftplite.h"
#include "ftpver.h"

BEGIN_SERVER_COMMAND_MAP
    ON_SERVER_COMMAND("USER", on_user)
    ON_SERVER_COMMAND("PASS", on_pass)
    ON_SERVER_COMMAND("REIN", on_rein)
    ON_SERVER_COMMAND("ABOR", on_abor)
    ON_SERVER_COMMAND("NOOP", on_noop)
    ON_SERVER_COMMAND("PASV", on_pasv)
    ON_SERVER_COMMAND("PORT", on_port)
    ON_SERVER_COMMAND("LIST", on_list)
    ON_SERVER_COMMAND("NLST", on_nlst)
    ON_SERVER_COMMAND("PWD",  on_pwd)
    ON_SERVER_COMMAND("CWD",  on_cwd)
    ON_SERVER_COMMAND("CDUP", on_cdup)
    ON_SERVER_COMMAND("REST", on_rest)
    ON_SERVER_COMMAND("RETR", on_retr)
    ON_SERVER_COMMAND("STOR", on_stor)
    ON_SERVER_COMMAND("STOU", on_stou)
    ON_SERVER_COMMAND("APPE", on_appe)
    ON_SERVER_COMMAND("QUIT", on_quit)
    ON_SERVER_COMMAND("MKD",  on_mkd)
    ON_SERVER_COMMAND("DELE", on_dele)
    ON_SERVER_COMMAND("RNFR", on_rnfr)
    ON_SERVER_COMMAND("RNTO", on_rnto)
    ON_SERVER_COMMAND("RMD",  on_rmd)
    ON_SERVER_COMMAND("TYPE", on_type)
    ON_SERVER_COMMAND("MODE", on_mode)
    ON_SERVER_COMMAND("STRU", on_stru)
    ON_SERVER_COMMAND("SYST", on_syst)
    ON_SERVER_COMMAND("HELP", on_help)
    ON_SERVER_COMMAND("STAT", not_implemented)
    ON_SERVER_COMMAND("SITE", not_implemented)
END_SERVER_COMMAND_MAP

// ʱʱ˳
void ftplite::timeout(void)
{
    _cleanup();
    trace("Idling timeout. Kicked.\n");
    write_string(std::string("421 ") + resource("IdleTimeout") + "\r\n");
    stop();
}

// ʽַ
std::string ftplite::_format(std::string format, std::string message)
{
    return euc::replace_all(format, "%s", message);
}

// ĳҪ¼
std::string ftplite::_login_required(std::string cmd)
{
    return std::string("530 ")
        + _format(resource("LoginRequired"), euc::to_upper(cmd))
        + "\r\n";
}

// ĳɹ
std::string ftplite::_successful(std::string number, std::string cmd)
{
    return number + std::string(" ")
        + _format(resource("Successful"), euc::to_upper(cmd)) + "\r\n";
}

// 
std::string ftplite::_wrong_paramnum(std::string cmd)
{
    return std::string("501 ")
        + _format(resource("WrongParamNum"), euc::to_upper(cmd))
        + "\r\n";
}

// Ч
std::string ftplite::_invalid_command(std::string cmd)
{
    return std::string("500 ")
        + _format(resource("InvalidCommand"), euc::to_upper(cmd))
        + "\r\n";
}

// ûӺʾӭϢ
std::string ftplite::welcome(bool *result)
{
    if (result)
        *result = true;
    return std::string("220 ")
        + _format(resource("Welcome"), FTPLITE_VERSION_STRING) + "\r\n";
}

// ˮʱʾϢ
std::string ftplite::poured(bool *result)
{
    if (result)
        *result = false;
    _cleanup();
    return std::string("421 " ) + resource("Poured") + "\r\n";
}

// û˳ʱʾϢ
std::string ftplite::bye(void)
{
    _cleanup();
    return std::string("221 ") + resource("Bye") + "\r\n";
}

// ޷ʶ
std::string ftplite::unhandled(std::string cmd, std::string param,
                               bool *result)
{
    std::string msg = euc::to_upper(cmd);
    if (param != "")
        msg += (" " + param);
    return std::string("500 ")
        + _format(resource("Unrecognizable"), msg) + "\r\n";
}

// δʵֵ
std::string ftplite::not_implemented(std::string cmd, std::string,
                                     bool *result)
{
    return std::string("502 ")
        + _format(resource("NotImplemented"), euc::to_upper(cmd))
        + "\r\n";
}

// Begin Server Handler Table

std::string ftplite::on_user(std::string cmd, std::string param,
                             bool *result)
{
    if (param == "")
    {
        return std::string("500 ")
            + _format(resource("MissingParam"), euc::to_upper(cmd))
            + "\r\n";
    }

    _username = param;
    if (get_config().get_value("Account", _username) == ""
        && get_config().get_value("Path", _username) != "")
    {
        _anonymous = true;
        return std::string("331 ") + resource("AnonymousLogin") + "\r\n";
    }

    _anonymous = false;
    return std::string("331 ")
        + _format(resource("PassRequired"), param)
        + "\r\n";
}

std::string ftplite::on_pass(std::string cmd, std::string param,
                             bool *result)
{
    if (_username == "")
    {
        return std::string("505 ")
            + resource("PassBeforeLogin") + "\r\n";
    }

    _root_path = get_config().get_value("Path", _username);

    if (!_anonymous
        && (get_config().get_value("Account", _username) != param
        || _root_path.size() < 2))
    {
        trace("'%s' is not logged in.\n", _username.c_str());
        return (std::string("530 ")
            + resource("LoginIncorrect")) + "\r\n";
    }

    _authorized = true;
    if (_root_path[_root_path.size() - 1] == euc::PATH_SEPARATOR)
        _root_path.resize(_root_path.size() - 1);

    trace("'%s' logged in successfully.\nHome directory is '%s'.\n",
        _username.c_str(), _root_path.c_str());

    _work_path = "/";

    if (_anonymous)
        return std::string("230 ") + resource("AnonymousOK") + "\r\n";

    return std::string("230 ")
        + _format(resource("LoginOK"), _username)
        + "\r\n";
}

std::string ftplite::on_rein(std::string cmd, std::string param,
                             bool *result)
{
    if (param != "")
        return unhandled(cmd, param, result);

    _username = "";
    _authorized = false;
    return std::string("220 ") + resource("Rein") + "\r\n";
}

std::string ftplite::on_abor(std::string cmd, std::string param,
                             bool *result)
{
    if (param != "")
        return unhandled(cmd, param, result);

    if (!_authorized)
        return _login_required(cmd);

    _cleanup();
    return _successful("226", cmd);
}

std::string ftplite::on_noop(std::string cmd, std::string param,
                             bool *result)
{
    return std::string("200 ") + resource("NoOp") + "\r\n";
}

std::string ftplite::on_pasv(std::string cmd, std::string param,
                             bool *result)
{
    if (param != "")
        return unhandled(cmd, param, result);

    if (!_authorized)
        return _login_required(cmd);

    _cleanup();
    SOCKET _listen_sock = socket(AF_INET, SOCK_STREAM, 0);
    if(_listen_sock == INVALID_SOCKET)
    {
        return std::string("425 ") + resource("OpenDataConnError")
            + "\r\n";
    }

    sockaddr_in listen_addr;
    memset(&listen_addr, 0, sizeof(listen_addr));
    listen_addr.sin_family      = AF_INET;
    listen_addr.sin_addr.s_addr = htonl(INADDR_ANY);
    listen_addr.sin_port        = 0;

    bind(_listen_sock, (sockaddr *) &listen_addr, sizeof(sockaddr_in));
    socklen_t nouse_size = sizeof(sockaddr_in);
    getsockname(_listen_sock, (sockaddr *) &listen_addr, &nouse_size);

    if (listen(_listen_sock, 0) != 0)
    {
        closesocket(_listen_sock);
        return std::string("425 ") + resource("OpenDataConnError")
            + "\r\n";
    }

    std::stringstream addr_str;

    sockaddr_in server_addr;
    getsockname(get_socket(), (sockaddr *) &server_addr, &nouse_size);
    unsigned char *ipaddr = (unsigned char *) &server_addr.sin_addr;
    unsigned char *portaddr = (unsigned char *) &listen_addr.sin_port;
    addr_str << "("
        << ((int) ipaddr[0]) << ","
        << ((int) ipaddr[1]) << ","
        << ((int) ipaddr[2]) << ","
        << ((int) ipaddr[3]) << ","
        << ((int) portaddr[0]) << ","
        << ((int) portaddr[1])
        << ")";

    _listener = new acceptor(_listen_sock);
    _listener->start();
    trace("Entering passive mode, using port %d.\n",
        ntohs(listen_addr.sin_port));

    _is_pasv = true;
    return std::string("227 ") + _format(resource("PassiveMode"),
        addr_str.str()) + "\r\n";
}

std::string ftplite::on_port(std::string cmd, std::string param,
                             bool *result)
{
    if (!_authorized)
        return _login_required(cmd);

    if (param == "")
        return _wrong_paramnum(cmd);

    _is_pasv = true;
    memset(&_data_addr, 0, sizeof(sockaddr_in));
    _data_addr.sin_family = AF_INET;

    unsigned char *ip = (unsigned char *) &_data_addr.sin_addr.s_addr;
    unsigned char *port = (unsigned char *) &_data_addr.sin_port;

    for (int i = 0; i < 4; ++i)
    {
        std::string::size_type pos = param.find(',');
        std::string num = param.substr(0, pos);
        if (pos == std::string::npos || pos == param.size() - 1)
            return _wrong_paramnum(cmd);
        param = param.substr(pos + 1);
        int data = atoi(num.c_str());
        if (data < 0 || data > 255)
            return _invalid_command(cmd);
        ip[i] = data;
    }

    std::string::size_type pos = param.find(',');
    std::string num = param.substr(0, pos);
    if (pos == std::string::npos || pos == param.size() - 1)
        return _wrong_paramnum(cmd);
    param = param.substr(pos + 1);
    int data = atoi(num.c_str());
    if (data <= 0 || data >= 256)
        return _invalid_command(cmd);
    port[0] = data;

    data = atoi(param.c_str());
    if (data <= 0 || data >= 256)
        return _invalid_command(cmd);
    port[1] = data;

    _is_pasv = false;
    return _successful("200", cmd);
}

std::string ftplite::on_list(std::string cmd, std::string param,
                             bool *result)
{
    return _do_list(cmd, param, false);
}

std::string ftplite::on_nlst(std::string cmd, std::string param,
                             bool *result)
{
    return _do_list(cmd, param, true);
}

std::string ftplite::on_pwd(std::string cmd, std::string param,
                            bool *result)
{
    if (!_authorized)
        return _login_required(cmd);

    if (param != "")
        return unhandled(cmd, param, result);

    return std::string("257 ")
        + _format(resource("CurrentPath"), _work_path) + "\r\n";
}

std::string ftplite::on_cwd(std::string cmd, std::string param,
                            bool *result)
{
    if (!_authorized)
        return _login_required(cmd);

    if (param == "")
        return _wrong_paramnum(cmd);

    std::string new_path = euc::path_simplify(_work_path, param);
    if (_folder_exists(_root_path + new_path))
    {
        _work_path = new_path;
        if (_work_path[new_path.size() -1 ] != '/')
            _work_path += "/";
        return _successful("250", cmd);
    }

    return std::string("550 ") + _format(resource("InvalidPath"), param)
        + "\r\n";
}

std::string ftplite::on_cdup(std::string cmd, std::string param,
                             bool *result)
{
    if (!_authorized)
        return _login_required(cmd);
    if (param != "")
        return unhandled(cmd, param, result);
    return on_cwd("CDUP", "..", result);
}

std::string ftplite::on_rest(std::string cmd, std::string param,
                             bool *result)
{
    if (!_authorized)
        return _login_required(cmd);

    if (param == "")
        return _wrong_paramnum(cmd);

    std::string::size_type i;
    for (i = 0; i < param.size(); ++i)
        if (param[i] < '0' || param[i] > '9')
            break;

    if (i != param.size())
        return std::string("501 ") + resource("RestError") + "\r\n";

    std::fstream::pos_type new_pos;
#if defined(UNIX) || defined(LINUX)
    new_pos = (std::fstream::pos_type) atoll(param.c_str());
#else
#if defined(_MSC_VER)
#pragma warning(disable: 4244)
#endif
    new_pos = (std::fstream::pos_type) _atoi64(param.c_str());
#endif

    if (new_pos < 0)
        return std::string("501 ") + resource("RestError") + "\r\n";

    std::stringstream formatter;
    formatter << new_pos;

    _rest_pos = new_pos;
    return std::string("350 ")
        + _format(resource("RestSet"), formatter.str()) + "\r\n";
}

std::string ftplite::on_retr(std::string cmd, std::string param,
                             bool *result)
{
    if (!_authorized)
        return _login_required(cmd);

    if (param == "")
        return _wrong_paramnum(cmd);

    std::string path = _root_path + euc::path_simplify(_work_path, param);
#ifdef WIN32
    for (std::string::size_type i = 0; i < path.size(); ++i)
    {
        if (path[i] == '/')
            path[i] = '\\';
    }
#endif
    if (_check_existence(path) != 2)
    {
        return std::string("550 ")
            + _format(resource("InvalidPath"), param) + "\r\n";
    }

    std::fstream file(path.c_str(), std::ios::in
        | (_type == Binary ? std::ios::binary
        : std::ios_base::openmode(0)));

    if (!file.good())
    {
        return std::string("550 ")
            + _format(resource("AccessDenied"), param) + "\r\n";
    }

    write_string(std::string("125 ") + _format(resource("RetrDataConn"),
        (_type == Binary) ? "BINARY" : "ASCII") + "\r\n");

    if (!_get_data_connection())
    {
        file.close();
        return std::string("425 ")
            + resource("OpenDataConnError") + "\r\n";
    }

    char buffer[TRANSFER_BUFFER_SIZE];
    file.seekg(_rest_pos);
    if (_type == Binary)
    {
        while (!file.eof())
        {
            _timer->reset();
            file.read(buffer, TRANSFER_BUFFER_SIZE);
            if (etseq::completely_send
                (_data_sock, buffer, file.gcount(), 0) == SOCKET_ERROR)
            {
                shutdown(_data_sock, SD_BOTH);
                closesocket(_data_sock);
                _data_sock = INVALID_SOCKET;
                break;
            }
        }
    }
    else
    {
        while (!file.eof())
        {
            _timer->reset();
            std::string line;
            while (file.peek() == '\n')
            {
                line += "\r\n";
                file.ignore();
            }

            if (!file.eof())
            {
                file.get(buffer, TRANSFER_BUFFER_SIZE);
                line += buffer;
            }

            if (etseq::completely_send(_data_sock, line.c_str(),
                (int) line.size(), 0) == SOCKET_ERROR)
            {
                shutdown(_data_sock, SD_BOTH);
                closesocket(_data_sock);
                _data_sock = INVALID_SOCKET;
                break;
            }
        }
    }

    file.close();
    _cleanup();
    return std::string("226 ") + resource("TransferComplete") + "\r\n";
}

std::string ftplite::on_stor(std::string cmd, std::string param,
                             bool *result)
{
    if (_anonymous)
    {
        return std::string("550 ")
            + _format(resource("AccessDenied"), param) + "\r\n";
    }

    if (!_authorized)
        return _login_required(cmd);

    if (param == "")
        return _wrong_paramnum(cmd);

    std::string path = _root_path + euc::path_simplify(_work_path, param);
#ifdef WIN32
    for (std::string::size_type i = 0; i < path.size(); ++i)
    {
        if (path[i] == '/')
            path[i] = '\\';
    }
#endif
    if (!_get_data_connection())
    {
        return std::string("425 ")
            + resource("OpenDataConnError") + "\r\n";
    }

    std::fstream file(path.c_str(), std::ios::out
        | (_rest_pos == (std::fstream::pos_type(0))
        ? std::ios_base::openmode(0) : std::ios::app)
        | (_type == Binary ? std::ios::binary
        : std::ios_base::openmode(0)));

    if (!file.good())
    {
        _cleanup();
        return std::string("550 ")
            + _format(resource("AccessDenied"), param) + "\r\n";
    }

    write_string(std::string("125 ") + _format(resource("StorDataConn"),
        (_type == Binary) ? "BINARY" : "ASCII") + "\r\n");

    file.seekp(_rest_pos);
    bool status = _store_file(file);
    file.close();

    _cleanup();

    if (status)
    {
        return std::string("226 ")
            + resource("TransferComplete") + "\r\n";
    }
    else
    {
        return std::string("552 ")
            + resource("OutOfSpace") + "\r\n";
    }
}

std::string ftplite::on_stou(std::string cmd, std::string param,
                             bool *result)
{
    if (_anonymous)
    {
        return std::string("550 ")
            + _format(resource("AccessDenied"), param) + "\r\n";
    }

    if (!_authorized)
        return _login_required(cmd);

    if (param != "")
        return unhandled(cmd, param, result);

    std::string path_temp = _root_path + _work_path + "flXXXXXX";
    char *buffer = new char[path_temp.size() + 1];
    strcpy(buffer, path_temp.c_str());
#if defined(UNIX) || defined(LINUX)
    mkstemp(buffer);
#else
    mktemp(buffer);
#endif
    std::string name(buffer);
    delete []buffer;
    name = name.substr(name.size() - 8);
    return on_stor(cmd, name, result);
}

std::string ftplite::on_appe(std::string cmd, std::string param,
                             bool *result)
{
    if (_anonymous)
    {
        return std::string("550 ")
            + _format(resource("AccessDenied"), param) + "\r\n";
    }

    if (_rest_pos != std::fstream::pos_type(0))
        return on_stor(cmd, param, result);

    if (!_authorized)
        return _login_required(cmd);

    if (param == "")
        return _wrong_paramnum(cmd);

    std::string path = _root_path + euc::path_simplify(_work_path, param);
#ifdef WIN32
    for (std::string::size_type i = 0; i < path.size(); ++i)
    {
        if (path[i] == '/')
            path[i] = '\\';
    }
#endif
    std::fstream file(path.c_str(), std::ios::out | std::ios::app
        | (_type == Binary ? std::ios::binary
        : std::ios_base::openmode(0)));

    if (!file.good())
    {
        return std::string("550 ")
            + _format(resource("AccessDenied"), param) + "\r\n";
    }

    write_string(std::string("125 ") + _format(resource("StorDataConn"),
        (_type == Binary) ? "BINARY" : "ASCII") + "\r\n");

    if (!_get_data_connection())
    {
        file.close();
        return std::string("425 ")
            + resource("OpenDataConnError") + "\r\n";
    }

    _store_file(file);
    file.close();

    _cleanup();
    return std::string("226 ") + resource("TransferComplete") + "\r\n";
}

std::string ftplite::on_quit(std::string cmd, std::string param,
                             bool *result)
{
    *result = false;
    _cleanup();
    return std::string();
}

std::string ftplite::on_mkd(std::string cmd, std::string param,
                            bool *result)
{
    if (_anonymous)
    {
        return std::string("550 ")
            + _format(resource("AccessDenied"), param) + "\r\n";
    }

    if (!_authorized)
        return _login_required(cmd);

    if (param == "")
        return _wrong_paramnum(cmd);

    std::string path = _root_path + euc::path_simplify(_work_path, param);
#ifdef WIN32
    for (std::string::size_type i = 0; i < path.size(); ++i)
    {
        if (path[i] == '/')
            path[i] = '\\';
    }
#endif
    if (_check_existence(path) != 0)
    {
        return std::string("550 ") + _format(resource("FileExists"), param)
            + "\r\n";
    }
#if defined(UNIX) || defined(LINUX)
    if (mkdir(path.c_str(), 0755) == 0)
#else
    if (mkdir(path.c_str()) == 0)
#endif
    {
        return std::string("257 ")
            + _format(resource("FolderCreated"), param) + "\r\n";
    }

    switch (errno)
    {
    case EEXIST:
        return std::string("550 ") + _format(resource("FileExists"), param)
            + "\r\n";
    case ENOENT:
        return std::string("550 ")
            + _format(resource("InvalidPath"), param) + "\r\n";
    }

#if defined(UNIX) || defined(LINUX)
    return std::string("550 ") + _format(resource("InvalidPath"), param)
        + "\r\n";
#else
    return std::string("553 ") + _format(resource("InvalidFile"), param)
        + "\r\n";
#endif
}

std::string ftplite::on_dele(std::string cmd, std::string param,
                             bool *result)
{
    if (_anonymous)
    {
        return std::string("550 ")
            + _format(resource("AccessDenied"), param) + "\r\n";
    }

    if (!_authorized)
        return _login_required(cmd);

    if (param == "")
        return _wrong_paramnum(cmd);

    std::string path = _root_path + euc::path_simplify(_work_path, param);
#ifdef WIN32
    for (std::string::size_type i = 0; i < path.size(); ++i)
    {
        if (path[i] == '/')
            path[i] = '\\';
    }
#endif
    if (_check_existence(path) != 2)
    {
        return std::string("550 ")
            + _format(resource("InvalidPath"), param) + "\r\n";
    }

    if (unlink(path.c_str()) == 0)
        return _successful("250", cmd);

    return std::string("550 ")
        + _format(resource("AccessDenied"), param) + "\r\n";
}

std::string ftplite::on_rnfr(std::string cmd, std::string param,
                             bool *result)
{
    if (_anonymous)
    {
        return std::string("550 ")
            + _format(resource("AccessDenied"), param) + "\r\n";
    }

    if (!_authorized)
        return _login_required(cmd);

    if (param == "")
        return _wrong_paramnum(cmd);

    std::string path = _root_path + euc::path_simplify(_work_path, param);
#ifdef WIN32
    for (std::string::size_type i = 0; i < path.size(); ++i)
    {
        if (path[i] == '/')
            path[i] = '\\';
    }
#endif
    if (_check_existence(path) == 0)
    {
        return std::string("550 ")
            + _format(resource("InvalidPath"), param) + "\r\n";
    }

    _source = path;
    return std::string("350 ")
        + _format(resource("RenameFrom"), param) + "\r\n";
}

std::string ftplite::on_rnto(std::string cmd, std::string param,
                             bool *result)
{
    if (_source == "")
    {
        return std::string("503 ")
            + resource("RntoBeforeRnfr") + "\r\n";
    }

    if (_anonymous)
    {
        return std::string("550 ")
            + _format(resource("AccessDenied"), param) + "\r\n";
    }

    if (!_authorized)
        return _login_required(cmd);

    if (param == "")
        return _wrong_paramnum(cmd);

    std::string path = _root_path + euc::path_simplify(_work_path, param);
#ifdef WIN32
    for (std::string::size_type i = 0; i < path.size(); ++i)
    {
        if (path[i] == '/')
            path[i] = '\\';
    }
#endif
    if (_check_existence(path) != 0)
    {
        return std::string("550 ")
            + _format(resource("InvalidPath"), param) + "\r\n";
    }

    if (rename(_source.c_str(), path.c_str()) == 0)
        return _successful("250", cmd);

    switch (errno)
    {
    case ENOENT:
        return std::string("550 ")
            + _format(resource("InvalidPath"), param) + "\r\n";
    case EACCES:
        return std::string("550 ")
            + _format(resource("AccessDenied"), param) + "\r\n";
    }

#if defined(UNIX) || defined(LINUX)
    return std::string("550 ")
        + _format(resource("InvalidFile"), param) + "\r\n";
#else
    return std::string("550 ") + _format(resource("InvalidFile"), param)
        + "\r\n";
#endif
}

std::string ftplite::on_rmd(std::string cmd, std::string param,
                            bool *result)
{
    if (_anonymous)
    {
        return std::string("550 ")
            + _format(resource("AccessDenied"), param) + "\r\n";
    }

    if (!_authorized)
        return _login_required(cmd);

    if (param == "")
        return _wrong_paramnum(cmd);

    std::string path = _root_path + euc::path_simplify(_work_path, param);
#ifdef WIN32
    for (std::string::size_type i = 0; i < path.size(); ++i)
    {
        if (path[i] == '/')
            path[i] = '\\';
    }
#endif
    trace("_work_path = \"%s\"\n", (_root_path + _work_path).c_str());
    trace("path = \"%s\"\n", path.c_str());
    if (euc::start_with(_root_path + _work_path, path)
        || _check_existence(path) != 1)
    {
        return std::string("550 ")
            + _format(resource("InvalidDirectory"), param) + "\r\n";
    }

    if (rmdir(path.c_str()) == 0)
        return _successful("250", cmd);

    switch (errno)
    {
    case ENOTEMPTY:
        return std::string("550 ") + _format(resource("NotEmpty"), param)
            + "\r\n";
    case ENOENT:
        return std::string("550 ")
            + _format(resource("InvalidDirectory"), param) + "\r\n";
    case EACCES:
        return std::string("550 ")
            + _format(resource("AccessDenied"), param) + "\r\n";
    }

#if defined(UNIX) || defined(LINUX)
    return std::string("550 ")
        + _format(resource("InvalidDirectory"), param) + "\r\n";
#else
    return std::string("550 ") + _format(resource("InvalidFile"), param)
        + "\r\n";
#endif
}

std::string ftplite::on_type(std::string cmd, std::string param,
                             bool *result)
{
    if (!_authorized)
        return _login_required(cmd);

    if (param == "")
        return _wrong_paramnum(cmd);

    if (param.size() > 1)
        return _invalid_command((cmd + " ") + param);

    param = euc::to_upper(param);
    switch (param[0])
    {
    case 'I':
        _type = Binary;
        break;
    case 'A':
        _type = ASCII;
        break;
    default:
        return unhandled(cmd, param, result);
    }

    return std::string("200 ")
        + _format(resource("TypeSet"), param) + "\r\n";
}

std::string ftplite::on_mode(std::string cmd, std::string param,
                             bool *result)
{
    if (!_authorized)
        return _login_required(cmd);

    if (param == "")
        return _wrong_paramnum(cmd);

    param = euc::to_upper(param);
    if (param == "S")
        return std::string("200 ") + _format(resource("ModeSet"), param)
            + "\r\n";

    return unhandled(cmd, param, result);
}

std::string ftplite::on_stru(std::string cmd, std::string param,
                             bool *result)
{
    if (!_authorized)
        return _login_required(cmd);

    if (param == "")
        return _wrong_paramnum(cmd);

    param = euc::to_upper(param);
    if (param == "F")
        return std::string("200 ") + _format(resource("StructSet"), param)
            + "\r\n";

    return unhandled(cmd, param, result);
}

std::string ftplite::on_syst(std::string cmd, std::string param,
                             bool *result)
{
    if (param != "")
        return unhandled(cmd, param, result);

    return std::string("215 ") + _format(resource("SystemType"), param)
        + "\r\n";
}

std::string ftplite::on_help(std::string cmd, std::string param,
                             bool *result)
{
    if (param != "")
        return unhandled(cmd, param, result);

    std::string msg = std::string("214-") + resource("Help") + "\r\n";

    msg += "   ABOR    APPE    CDUP    CWD     DELE    HELP    \r\n";
    msg += "   LIST    MKD     MODE*   NLST    NOOP    PASS    \r\n";
    msg += "   PASV    PORT    PWD     QUIT    REIN    REST    \r\n";
    msg += "   RETR    RMD     RNFR    RNTO    SITE*   STAT*   \r\n";
    msg += "   STOR    STOU    STRU*   SYST    TYPE*   USER    \r\n";

    msg += _successful("214  ", cmd);
    return msg;
}

// End Server Handler Table
