/*  ftplite ʵ
    Ȩ(C)  2003

    һ GNU ͨù
֤޸ĺ·һ򡣻֤ĵڶ棬ߣѡ
κθµİ汾
    һĿϣãûκεûʺضĿ
ĵĵϸ GNU ͨù֤
    ӦѾͳһյһ GNU ͨù֤ĸûУ
дŸ
    The Free Software Foundation, Inc.,  675  Mass Ave,  Cambridge,
    MA02139,  USA

    ڱʲô⣬ϵ
    E-mailedyfox@sohu.com */
#include "ftplite.h"
#include "ftplist.h"
#if defined(UNIX) || defined(LINUX)
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#endif

// Դ
void ftplite::_cleanup(void)
{
    if (_listener)
    {
        _listener->stop();
        _listener->wait();
        SYNCHRONIZED(_lock);
        delete _listener;
        _listener = NULL;
    }

    if (_data_sock != INVALID_SOCKET)
    {
        shutdown(_data_sock, SD_BOTH);
        closesocket(_data_sock);
        _data_sock = INVALID_SOCKET;
    }
}

// ȡ
bool ftplite::_get_data_connection(void)
{
    if (_is_pasv)
    {
        // Passive mode
        if (_listener == NULL)
            return false;

        _listener->wait();
        if ((_data_sock = _listener->get_socket()) == INVALID_SOCKET)
        {
            _cleanup();
            return false;
        }
    }
    else
    {
        // Port mode
        _data_sock = socket(AF_INET, SOCK_STREAM, 0);
        if (connect(_data_sock, (sockaddr *) &_data_addr,
            sizeof(sockaddr_in)) != 0)
            return false;
    }

    return true;
}

// Դԡ0 Ϊڣ1 ΪļУ2 Ϊļ
int ftplite::_check_existence(std::string path)
{
#if defined(UNIX) || defined(LINUX)
    struct stat st;
    if (stat(path.c_str(), &st) != 0)
        return 0;

    if (S_ISDIR(st.st_mode & S_IFMT))
        return 1;

    return 2;
#else
    for (std::string::size_type i = 0; i < path.size(); ++i)
    {
        if (path[i] == '/')
            path[i] = '\\';
    }

    WIN32_FIND_DATA wfd;

    std::string item(euc::rtrim(path, '\\'));
    if (item.find('*') != std::string::npos
        || item.find('?') != std::string::npos)
        return 0;

    if (item[1] == ':' && item.size() == 2)
    {
        UINT type = GetDriveType(path.c_str());
        if (type == DRIVE_NO_ROOT_DIR || type == DRIVE_UNKNOWN)
            return 0;
        return 1;
    }

    HANDLE handle;
    if ((handle = FindFirstFile(item.c_str(), &wfd))
        == INVALID_HANDLE_VALUE)
        return 0;
    FindClose(handle);

    if (wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
        return 1;
    return 2;
#endif
}

// жָļǷ
bool ftplite::_file_exists(std::string path)
{
    return _check_existence(path) == 2;
}

// жָļǷ
bool ftplite::_folder_exists(std::string path)
{
    return _check_existence(path) == 1;
}

// Ŀ¼
std::string ftplite::_do_list(std::string cmd, std::string param,
                              bool simple)
{
    if (!_authorized)
        return _login_required(cmd);

    write_string(std::string("150 ")
        + _format(resource("ListDataConn"), "ASCII") + "\r\n");

    if (!_get_data_connection())
    {
        return std::string("425 ")
            + resource("OpenDataConnError") + "\r\n";
    }

    if (param.size() && param[0] == '-')
    {
        std::string::size_type next = param.find(' ');
        if (next == std::string::npos || next == param.size() - 1)
            param = "";
        else
            param = param.substr(next + 1);
    }

    std::string path = _root_path + euc::path_simplify(_work_path, param);
#ifdef WIN32
    for (std::string::size_type i = 0; i < path.size(); ++i)
    {
        if (path[i] == '/')
            path[i] = '\\';
    }
#endif
    if (list(path.c_str(), _data_sock, simple))
    {
        _cleanup();
        return std::string("226 ") + resource("TransferComplete") + "\r\n";
    }
    else
    {
        _cleanup();
        if (param == "")
        {
            std::string last;
            if (_work_path == "/")
                last = "/";
            else
            {
                last = _work_path.substr(_work_path.rfind('/',
                    _work_path.size() - 2) + 1, _work_path.size() - 2);
            }
            return std::string("550 ")
                + _format(resource("FileNotFound"), last) + "\r\n";
        }

        return std::string("550 ")
            + _format(resource("FileNotFound"), param) + "\r\n";
    }
}

// ϴļ
bool ftplite::_store_file(std::fstream &file)
{
    char buffer[TRANSFER_BUFFER_SIZE];

    if (_type == Binary)
    {
        int size = 0;
        while ((size = recv(_data_sock, buffer,
            TRANSFER_BUFFER_SIZE, 0)) > 0)
        {
            _timer->reset();
            file.write(buffer, size);
        }
    }
    else
    {
        int size = 0;

        while ((size = recv(_data_sock, buffer,
            TRANSFER_BUFFER_SIZE, 0)) > 0)
        {
            _timer->reset();
            std::string line(buffer, size);
            std::string::size_type pos;

            while ((pos = line.find('\n')) != std::string::npos)
            {
                std::string curline;
                if (pos > 0 && line[pos - 1] == '\r')
                    curline = line.substr(0, pos - 1);
                else
                    curline = line.substr(0, pos);

                if (pos < line.size() - 1)
                    line = line.substr(pos + 1);
                else
                    line = "";

                file << curline << std::endl;
            }

            if (line != "")
                file << line;
        }
    }

    return file.good();
}
