/*  ftplite Ŀ¼
    Ȩ(C)  2003

    һ GNU ͨù
֤޸ĺ·һ򡣻֤ĵڶ棬ߣѡ
κθµİ汾
    һĿϣãûκεûʺضĿ
ĵĵϸ GNU ͨù֤
    ӦѾͳһյһ GNU ͨù֤ĸûУ
дŸ
    The Free Software Foundation, Inc.,  675  Mass Ave,  Cambridge,
    MA02139,  USA

    ڱʲô⣬ϵ
    E-mailedyfox@sohu.com */
#include "ftplist.h"
#include "sync.h"
#include "critical_section.h"

const char *month_str[] = { "Jan", "Feb", "Mar", "Apr", "May", "Jun",
                            "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"};

#define write_socket(sock, str) etseq::completely_send(sock, str, \
    (int) strlen(str), 0)

#if defined(UNIX) || defined(LINUX)

static std::string username(uid_t uid)
{
    static euc::critical_section lock;
    euc::auto_lock syncer(lock);

    std::stringstream result;
    struct passwd *pw = getpwuid(uid);

    if (pw)
        result << pw->pw_name;
    else
        result << uid;

    return result.str();
}

static std::string groupname(gid_t gid)
{
    static euc::critical_section lock;
    euc::auto_lock syncer(lock);

    std::stringstream result;
    struct group *gr = getgrgid(gid);

    if (gr)
        result << gr->gr_name;
    else
        result << gid;

    return result.str();
}

static bool list_item(const char *const path, SOCKET sock)
{
    struct stat st;
    if (stat(path, &st) != 0)
        return false;

    std::stringstream line;

    switch (st.st_mode & S_IFMT)
    {
    case S_IFSOCK:
        line << "s";
        break;
    case S_IFLNK:
        line << "l";
        break;
    case S_IFCHR:
        line << "c";
        break;
    case S_IFIFO:
        line << "p";
        break;
    case S_IFDIR:
        line << "d";
        break;
    default:
        line << "-";
    }

    for (int i = 8; i >= 0; --i)
    {
       if ((st.st_mode & (1 << i)) == 0)
            line << "-";
        else
        {
            switch (i % 3)
            {
            case 0:
                line << "x";
                break;
            case 1:
                line << "w";
                break;
            case 2:
                line << "r";
                break;
            }
        }
    }

    line << std::setw(4) << st.st_nlink;
    line << " " << std::left << std::setw(8) << username(st.st_uid);
    line << " " << std::left << std::setw(8) << groupname(st.st_gid);
    line << " " << std::right << std::setw(8) << st.st_size;

    struct tm *timest = localtime(&st.st_mtime);
    line << " " << month_str[timest->tm_mon] << " "
        << std::setw(2) << timest->tm_mday;

    time_t now = time(NULL);

    if (now - st.st_mtime < 26 * 7 * 24 * 3600L
        && st.st_mtime - now < 15 * 60L)
    {
        line << " " << std::setw(2) << std::setfill('0')
            << timest->tm_hour << ":" << std::setw(2) << std::setfill('0')
            << timest->tm_min;
    }
    else
    {
        line << "  " << std::setw(4) << std::setfill('0')
            << timest->tm_year + 1900;
    }

    line << " " << euc::getfilename(path) << "\r\n";
    return write_socket(sock, line.str().c_str()) != SOCKET_ERROR;
}

static bool list_directory(const char *const path, SOCKET sock, bool simple)
{
    DIR *d;
    struct dirent *e;
    if ((d = opendir(path)) == NULL)
        return false;

    std::string dirname(path);
    if (*dirname.rbegin() != '/')
        dirname += '/';

    while ((e = readdir(d)) != NULL)
    {
        if (std::string(".") != e->d_name
            && std::string("..") != e->d_name)
        {
            if (simple)
            {
                if (write_socket(sock,
                    (std::string(e->d_name) + "\r\n").c_str())
                    == SOCKET_ERROR)
                    break;
            }
            else
            {
                if (!list_item((dirname + e->d_name).c_str(), sock))
                    break;
            }
        }
    }

    return true;
}

bool list(const char *const path, SOCKET sock, bool simple)
{
    struct stat st;
    if (stat(path, &st) != 0)
        return false;

    if (S_ISDIR(st.st_mode & S_IFMT))
        return list_directory(path, sock, simple);

    if (simple)
        write_socket(sock, (euc::getfilename(path) + "\r\n").c_str());
    else
        return list_item(path, sock);

    return true;
}

#else

static bool list_item(WIN32_FIND_DATA &wfd, SOCKET sock)
{
    std::stringstream line;
    int i;

    if (wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
        line << "d";
    else
        line << "-";

    std::string permission("r");

    if (wfd.dwFileAttributes & FILE_ATTRIBUTE_READONLY)
        permission += "-";
    else
        permission += "w";

    std::string file(wfd.cFileName);
    std::string ext;
    if (file.size() > 3)
        ext = euc::to_upper(file.substr(file.size() - 4));
    if ((wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
        || (file.size() > 3
        && (ext == ".COM" || ext == ".EXE" || ext == ".BAT")))
        permission += "x";
    else
        permission += "-";

    for (i = 0; i < 3; ++i)
        line << permission;

    line << "   1 user     group   ";
    line << " " << std::right << std::setw(8)
        << (wfd.nFileSizeHigh * 0x100000000LL + wfd.nFileSizeLow);

    SYSTEMTIME timest;
    FileTimeToSystemTime(&wfd.ftLastWriteTime, &timest);

    line << " " << month_str[timest.wMonth - 1] << " "
        << std::setw(2) << timest.wDay;

    tm mod_time;
    mod_time.tm_year  = timest.wYear - 1900;
    mod_time.tm_mon   = timest.wMonth - 1;
    mod_time.tm_mday  = timest.wDay;
    mod_time.tm_hour  = timest.wHour;
    mod_time.tm_min   = timest.wMinute;
    mod_time.tm_sec   = timest.wSecond;
    mod_time.tm_isdst = false;

    time_t previous = mktime(&mod_time);
    time_t now = time(NULL);

    if (now - previous < 26 * 7 * 24 * 3600L && previous - now < 15 * 60L)
    {
        line << " " << std::setw(2) << std::setfill('0')
            << timest.wHour << ":" << std::setw(2) << std::setfill('0')
            << timest.wMinute;
    }
    else
    {
        line << "  " << std::setw(4) << std::setfill('0')
            << timest.wYear;
    }

    line << " " << file << "\r\n";

    return write_socket(sock, line.str().c_str()) != SOCKET_ERROR;
}

static bool list_directory(const char *const path, SOCKET sock,
                           bool simple)
{
    std::string dirname(path);
    if (*dirname.rbegin() != '\\')
        dirname += '\\';
    dirname += "*.*";

    WIN32_FIND_DATA wfd;
    HANDLE handle;

    handle = FindFirstFile(dirname.c_str(), &wfd);
    if (handle == INVALID_HANDLE_VALUE)
        return false;

    BOOL not_finished = (handle != INVALID_HANDLE_VALUE);
    while (not_finished)
    {
        if (std::string(".") != wfd.cFileName && std::string("..")
            != wfd.cFileName)
        {
            if (simple)
            {
                if (write_socket
                    (sock, (std::string(wfd.cFileName) + "\r\n").c_str())
                    == SOCKET_ERROR)
                    break;
            }
            else
            {
                if (!list_item(wfd, sock))
                    break;
            }
        }

        not_finished = FindNextFile(handle, &wfd);
    }


    FindClose(handle);
    return true;
}

bool list(const char *const path, SOCKET sock, bool simple)
{
    WIN32_FIND_DATA wfd;

    std::string item(euc::rtrim(path, '\\'));
    if (item.find('*') != std::string::npos
        || item.find('?') != std::string::npos)
        return false;

    if (item[1] == ':' && item.size() == 2)
        return list_directory(path, sock, simple);

    HANDLE handle;
    if ((handle = FindFirstFile(item.c_str(), &wfd))
        == INVALID_HANDLE_VALUE)
        return false;

    FindClose(handle);
    if (wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
        return list_directory(path, sock, simple);

    list_item(wfd, sock);
    return true;
}

#endif
